<?php
if(!isset($_SESSION)){ session_start(); }

// connect to mysql
require("inc/dbconnect.php");
require("inc/langutil.php");

// Get additional passed-in vars from login form
$nLoginPageID = (isset($_GET["pid"]) ? trim($_GET["pid"]) : NULL);
$nDefaultLang = (isset($_GET["dl"]) ? trim($_GET["dl"]) : NULL);
$nTranslateLang = (isset($_GET["tl"]) ? trim($_GET["tl"]) : NULL);

// Clean for security
$nLoginPageID = preg_replace("/[[:^digit:]]/", '',$nLoginPageID);
$nDefaultLang = nSanitizeGeneralText(substr(trim($nDefaultLang),0,2));
$nTranslateLang = nSanitizeGeneralText(substr(trim($nTranslateLang),0,2));

// Get a few settings
$nSettingsARRAY = array();
$nSQL = "SELECT * FROM nSettings";
mysql_select_db($DBName); $Result = mysql_query($nSQL,$Link);
if($Result===FALSE){ exit("Settings for your website could not be loaded.  This most likely means that your installation has failed.<BR><BR>Please run the <a href=\"./installer.php\">WPM installer</a> again, or if it does not exist, copy it again along with the 'installer' folder to the root of your website."); }
while($Row = mysql_fetch_array($Result)){
	$nSetting = $Row["nSetting"];
	$nValue = $Row["nValue"];
	$nSettingsARRAY[$nSetting] = $nValue;
}
if(count($nSettingsARRAY)>0){
	// site settings
	$nPermalinks = (isset($nSettingsARRAY["permalinks"]) ? $nSettingsARRAY["permalinks"] : NULL);
	$nFullSitePath = (isset($nSettingsARRAY["fullSitePath"]) ? $nSettingsARRAY["fullSitePath"] : NULL);
}

// Decide on how to extend a URL if permalinks are active or inactive
$nLoginPageURL = $nFullSitePath;
$nPathExtender = "?";
if(!$nPermalinks){ $nPathExtender = "&"; }

if($nLoginPageID){ $nLoginPageURL = tmplGetPageLinkPath($nLoginPageID); }
if($nLoginPageURL && substr($nLoginPageURL,-1)=="/"){ $nPathExtender = "?"; }

// Close user session and go back to login form, if available
if(!isset($_SESSION)){ session_start(); }
echo "<pre style=\"border:1px solid #555; overflow:auto; height:200px; width:100%;\">"; print_r($_SESSION); echo "</pre>";
$_SESSION = array(); 
unset($_SESSION["nSessWebUser"]);
unset($_SESSION["nSessWebUserID"]);
session_destroy();
header ("Location: {$nLoginPageURL}{$nPathExtender}msg=1");
exit;


// Utility functions
function nSanitizeGeneralText($nText){
	$notAllowed = array("<",">","\"","'","(",")","=","%");
	$nText = trim(str_replace($notAllowed,"",$nText));
	return $nText;
}
function tmplGetPageLinkPath($nPageID,$nFullParamARRAY=""){
	global $DBName,$Link,$nDefaultLang,$nSFLang,$nPermalinks,$nForceMobile;
	global $nFullSitePath;
	if(!$nPageID){ return; }
	
	$nType = $nTitle = $nNavTitle = "";
	
	$nSQL = "SELECT nType,nTitle,nNavTitle FROM nPage WHERE nID=$nPageID LIMIT 1";
	mysql_select_db($DBName); $Result = mysql_query($nSQL,$Link);
	if($Row = mysql_fetch_array($Result)){
		$nType = $Row["nType"];
		$nTitle = $Row["nTitle"];
		$nNavTitle = $Row["nNavTitle"];
	}
	
	// Mobile version override
	$nForceMobileLink = $nForceMobile;
	$nForceMobileOverride = nGetParam("MOBILE",$nFullParamARRAY); // override force mobile
	if($nForceMobileOverride || $nForceMobileOverride===0){ $nForceMobileLink = $nForceMobileOverride; }
	
	$nTranslateType="page"; $nTranslateID=$nPageID;
	// if translation is needed...
	$nTranslateLang = nGetParam("LANG",$nFullParamARRAY); // override translation language
	if(!$nTranslateLang){ $nTranslateLang = $nSFLang; } // if no override, use session language
	$nTranslation = nGetTranslation($nTranslateLang,$nTranslateID,"nText",$nTranslateType);
	if($nTranslation){ $nNavTitle = $nTranslation; }
	
	switch($nType){
		case "Homepage": if(!$nForceMobileLink){ $nPagePath = $nFullSitePath; } else { $nPagePath = $nFullSitePath."?&m=1"; } break;
		case "Search": $nPagePath = $nFullSitePath."search.php"; break;
		case "Link":
			// get link extension
			$nLinkInfo = pathinfo($nTitle);
			if(isset($nLinkInfo["extension"])){ $nLinkExt = strtolower($nLinkInfo["extension"]); } else { $nLinkExt = ""; }
			$nSitePathARRAY = parse_url($nFullSitePath);
			$nLinkARRAY = parse_url($nTitle);
			// if the link is external or to a PDF, open in new window
			if(isExternalLink($nTitle) || $nLinkExt=="pdf"){
				$nPagePath = $nTitle."\" target=\"newWin\" onclick=\"PopUp(this.href,this.target,800,600,1);";
			} else {
				$nPagePath = $nTitle;
			}
			break;
		default:
			if($nPermalinks && !$nForceMobileLink){
				$nPageNameForPath = nPrepareNameForPath($nNavTitle); // for mod-rewrite
				$nPagePath = $nPageID."/".$nPageNameForPath.".html"; // for mod-rewrite
				$nPagePath = $nFullSitePath.$nPagePath;
			} else {
				if(!$nForceMobileLink){ $nPagePath = $nFullSitePath."content.php?id=$nPageID"; } else { $nPagePath = $nFullSitePath."content.php?id=$nPageID&m=1"; }
			}
			break;
	}
	return $nPagePath;
}
function nGetParam($nParamToGet,$nFullParamARRAY){
	$nParamValue = "";
	if($nFullParamARRAY){
		foreach($nFullParamARRAY as $nParam) {
			$nParamARRAY = explode("=",$nParam,2); // explode, just getting the first '=' in array so user can add their own in params and not mess things up
			if($nParamARRAY[0]==$nParamToGet){ $nParamValue = $nParamARRAY[1]; }
		}
	}
	return $nParamValue;
}
function isExternalLink($nLink){
	global $nFullSitePath;
	if(!$nLink){ return; }
	$nSitePathARRAY = parse_url($nFullSitePath);
	$nLinkARRAY = parse_url($nLink);
	// if "http" exists, now search deeper
	if(isset($nLinkARRAY["scheme"])){
		$nSitePathHost = str_replace("www.","",$nSitePathARRAY["host"]);
		$nLinkHost = str_replace("www.","",$nLinkARRAY["host"]);
		// if link host name is not the same as the site's host name, this is an external link
		if($nSitePathHost!=$nLinkHost){ return true; }
	}
	return false;
}
?>
